/**
 * Copyright (c) 2010-2012, Abel Hegedus, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Abel Hegedus - initial API and implementation
 */
package org.eclipse.viatra.addon.querybasedfeatures.tooling;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.viatra.addon.querybasedfeatures.runtime.QueryBasedFeatureKind;
import org.eclipse.viatra.query.patternlanguage.emf.vql.Annotation;
import org.eclipse.viatra.query.patternlanguage.emf.vql.Pattern;

@SuppressWarnings("all")
public class QueryBasedFeatureParameters {
  public Pattern pattern;
  
  public Annotation annotation;
  
  public String sourceVar;
  
  public String targetVar;
  
  public EPackage ePackage;
  
  public EClass source;
  
  public EClass target;
  
  public EStructuralFeature feature;
  
  public QueryBasedFeatureKind kind;
  
  public boolean keepCache;
  
  public boolean useAsSurrogate;
  
  public boolean resourceWritable = true;
}
